/*      TOS.H

        Tos Definition Includes

        Copyright (c) Borland International 1990
        All Rights Reserved.
*/


#if !defined( __TOS )
#define __TOS

#include <trap.h>		/* AHCC: __syscall__ */

typedef struct          /* used by Cconrs */
{
        unsigned char maxlen;
        unsigned char actuallen;
        char    buffer[255];
} LINE;


typedef struct          /* used by Fsetdta, Fgetdta */
{
    char            d_reserved[21];
    unsigned char   d_attrib;
    unsigned int    d_time;
    unsigned int    d_date;
    unsigned long   d_length;
    char            d_fname[14];
} DTA;


typedef struct          /* used by Dfree */
{
    unsigned long   b_free;
    unsigned long   b_total;
    unsigned long   b_secsiz;
    unsigned long   b_clsiz;
} DISKINFO;


typedef struct baspag   /* used by Pexec */
{
        void    *p_lowtpa;
        void    *p_hitpa;
        void    *p_tbase;
        long    p_tlen;
        void    *p_dbase;
        long    p_dlen;
        void    *p_bbase;
        long    p_blen;
        DTA     *p_dta;
        struct baspag *p_parent;
        long    p_resrvd0;
        char    *p_env;
        char    p_stdfh[6];
        char    p_resrvd1;
        char    p_curdrv;
        long    p_resrvd2[18];
        char    p_cmdlin[128];
} BASPAG;


typedef struct          /* used by Getbpb */
{
        int     recsiz;
        int     clsiz;
        int     clsizb;
        int     rdlen;
        int     fsiz;
        int     fatrec;
        int     datrec;
        int     numcl;
        int     bflags;
} BPB;


typedef struct
{
        unsigned int  time;
        unsigned int  date;
} DOSTIME;


typedef struct          /* used by Iorec */
{
        void    *ibuf;
        int     ibufsiz;
        int     ibufhd;
        int     ibuftl;
        int     ibuflow;
        int     ibufhi;
} IOREC;


typedef struct          /* used by Kbdvbase */
{
        void    (*kb_midivec)();
        void    (*kb_vkbderr)();
        void    (*kb_vmiderr)();
        void    (*kb_statvec)();
        void    (*kb_mousevec)();
        void    (*kb_clockvec)();
        void    (*kb_joyvec)();
        void    (*kb_midisys)();
        void    (*kb_kbdsys)();
} KBDVBASE;


typedef struct          /* used by Pexec */
{
        unsigned char   length;
        char            command_tail[128];
} COMMAND;


typedef struct          /* used by Initmouse */
{
        char    topmode;
        char    buttons;
        char    x_scale;
        char    y_scale;
        int     x_max;
        int     y_max;
        int     x_start;
        int     y_start;
} MOUSE;


typedef struct          /* used by Prtblk */
{
        void    *pb_scrptr;
        int     pb_offset;
        int     pb_width;
        int     pb_height;
        int     pb_left;
        int     pb_right;
        int     pb_screz;
        int     pb_prrez;
        void    *pb_colptr;
        int     pb_prtype;
        int     pb_prport;
        void    *pb_mask;
} PBDEF;


typedef struct          /* used by Keytbl */
{
        char *unshift;
        char *shift;
        char *capslock;
} KEYTAB;


typedef struct __md
{
        struct __md *m_link;
        void        *m_start;
        long        m_length;
        BASPAG      *m_own;
} MD;


typedef struct          /* used by Getmpb */
{
        MD *mp_mfl;
        MD *mp_mal;
        MD *mp_rover;
} MPB;

typedef struct
{
        int   (*Bconstat) ();
        long  (*Bconin) ();
        int   (*Bcostat) ();
        void  (*Bconout) ();
        long  (*Rsconf) ();
        IOREC *iorec;
} MAPTAB;

typedef struct
{
        MAPTAB *maptab;
        int    maptabsize;
} BCONMAP;

/* system variable _sysbase (0x4F2L) points to next structure         */
typedef struct _syshdr
{
    unsigned       os_entry;   /* $00 BRA to reset handler             */
    unsigned       os_version; /* $02 TOS version number               */
    void           *os_start;  /* $04 -> reset handler                 */
    struct _syshdr *os_base;   /* $08 -> baseof OS                     */
    void           *os_membot; /* $0c -> end BIOS/GEMDOS/VDI ram usage */
    void           *os_rsv1;   /* $10 << unused,reserved >>            */
    long           *os_magic;  /* $14 -> GEM memoryusage parm. block   */
    long           os_gendat;  /* $18 Date of system build($MMDDYYYY)  */
    int            os_palmode; /* $1c OS configuration bits            */
    int            os_gendatg; /* $1e DOS-format date of systembuild   */
/*
    The next three fields are only available in TOS versions 1.2 and
    greater
*/
    void           *_root;     /* $20 -> base of OS pool               */
    long           *kbshift;   /* $24 -> keyboard shift state variable */
    BASPAG         **_run;     /* $28 -> GEMDOS PID of current process */
    void           *p_rsv2;    /* $2c << unused, reserved >>           */
} SYSHDR;



/* attributes for Fcreate/Fsfirst/Fsnext: */

#define FA_READONLY     0x01
#define FA_HIDDEN       0x02
#define FA_SYSTEM       0x04
#define FA_VOLUME       0x08
#define FA_SUBDIR       0x10
#define FA_ARCHIVE      0x20

/* Fopen modes: */

#define FO_READ         0
#define FO_WRITE        1
#define FO_RW           2

extern BASPAG *_BasPag;
extern unsigned long _PgmSize;

long    TRAP( 1)	gemdos( void, ... );
long    TRAP(13)	bios  ( void, ... );
long    TRAP(14)	xbios ( void, ... );

/****** Tos *************************************************************/

void    __GEMDOS__(0)	Pterm0( void );
long    __GEMDOS__(1)	Cconin( void );
void    __GEMDOS__(2)	Cconout( int   c );
int     __GEMDOS__(3)	Cauxin( void );
void    __GEMDOS__(4)	Cauxout( int   c );
int     __GEMDOS__(5)	Cprnout( int   c );
long    __GEMDOS__(6)	Crawio( int   w );
long    __GEMDOS__(7)	Crawcin( void );
long    __GEMDOS__(8)	Cnecin( void );
int     __GEMDOS__(9)	Cconws( const char *buf );
void    __GEMDOS__(10)	Cconrs( LINE *buf );
int     __GEMDOS__(11)	Cconis( void );
long    __GEMDOS__(14)	Dsetdrv( int   drv );
int     __GEMDOS__(16)	Cconos( void );
int     __GEMDOS__(17)	Cprnos( void );
int     __GEMDOS__(18)	Cauxis( void );
int     __GEMDOS__(19)	Cauxos( void );
int     __GEMDOS__(25)	Dgetdrv( void );
void    __GEMDOS__(26)	Fsetdta( DTA *buf );
long    __GEMDOS__(32)	Super( void *stack );
unsigned int   __GEMDOS__(42)	Tgetdate( void );
unsigned int   __GEMDOS__(43)	Tsetdate( unsigned int   date );
unsigned int   __GEMDOS__(44)	Tgettime( void );
unsigned int   __GEMDOS__(45)	Tsettime( unsigned int   time );
DTA  *  __GEMDOS__(47)	Fgetdta( void );
int     __GEMDOS__(48)	Sversion( void );
void    __GEMDOS__(49)	Ptermres( long keepcnt, int   retcode );
int     __GEMDOS__(54)	Dfree( DISKINFO *buf, int   driveno );
int     __GEMDOS__(57)	Dcreate( const char *path );
int     __GEMDOS__(58)	Ddelete( const char *path );
int     __GEMDOS__(59)	Dsetpath( const char *path );
long    __GEMDOS__(60)	Fcreate( const char *filename, int   attr );
long    __GEMDOS__(61)	Fopen( const char *filename, int   mo );
int     __GEMDOS__(62)	Fclose( int   handle );
long    __GEMDOS__(63)	Fread( int   handle, long count, void *buf );
long    __GEMDOS__(64)	Fwrite( int   handle, long count, void *buf );
int     __GEMDOS__(65)	Fdelete( const char *filename );
long    __GEMDOS__(66)	Fseek( long offset, int   handle, int   seekmode );
int     __GEMDOS__(67)	Fattrib( const char *filename, int   wflag, int   attrib );
long    __GEMDOS__(69)	Fdup( int   handle );
int     __GEMDOS__(70)	Fforce( int   stch, int   nonstdh );
int     __GEMDOS__(71)	Dgetpath( char *path, int   driveno );
void *  __GEMDOS__(72)	Malloc( long number );
int     __GEMDOS__(73)	Mfree( void *block );
int     __GEMDOS__(74)	Mshrink( int   zero, void *block, long newsiz );
long    __GEMDOS__(75)	Pexec( int   mo, char *ptr1, void *ptr2, void *ptr3 );
void    __GEMDOS__(76)	Pterm( int   retcode );
int     __GEMDOS__(78)	Fsfirst( const char *filename, int  attr );
int     __GEMDOS__(79)	Fsnext( void );
int     __GEMDOS__(86)	Frename( int  zero, const char *oldname, const char *newname );
int     __GEMDOS__(87)	Fdatime( DOSTIME *timeptr, int  handle, int  wflag );
int     __GEMDOS__(0x119)	Pdomain( int  newdom );
void *  __GEMDOS__(0x112)	Psignal( int  sig, void *handler );

/****** TOS 030 Gemdos Extension ****************************************/

void *  __GEMDOS__(68)	Mxalloc( long number, int  mo );
long    __GEMDOS__(20)	Maddalt( void *start, long size );

/****** Network Gemdos Extension ****************************************/

long    __GEMDOS__(92)	Flock( int  handle, int  mo, long start, long length );

/****** Bios ************************************************************/

void    __BIOS__( 0)	Getmpb( MPB *ptr );
int     __BIOS__( 1)	Bconstat( int  dev );
long    __BIOS__( 2)	Bconin( int  dev );
long    __BIOS__( 3)	Bconout( int  dev, int  c );
long    __BIOS__( 4)	Rwabs( int  rwflag, void *buf, int  cnt, int  recnr, int  dev );
void    (* __BIOS__(5)	Setexc( int  number, void (*exchdlr)() )) ();
long    __BIOS__( 6)	Tickcal( void );
BPB *	__BIOS__( 7)	Getbpb( int  dev );
long    __BIOS__( 8)	Bcostat( int  dev );
long    __BIOS__( 9)	Mediach( int  dev );
long    __BIOS__(10)	Drvmap( void );
long    __BIOS__(11)	Kbshift( int  mo );
long    __BIOS__(12)	Lrwabs( int  rwflag, void *buf, int  cnt, int  recnr, int  dev );

/****** XBios ***********************************************************/

void    __XBIOS__(0)	Initmouse( int  type, MOUSE *par, void (*mousevec)() );
void *	__XBIOS__(1)	Ssbrk( int  count );
void *  __XBIOS__(2)	Physbase( void );
void *	__XBIOS__(3)	Logbase( void );
int     __XBIOS__(4)	Getrez( void );
void    __XBIOS__(5)	Setscreen( void *laddr, void *paddr, int  rez );
void    __XBIOS__(6)	Setpalette( void *pallptr );
int     __XBIOS__(7)	Setcolor( int  colornum, int  color );
int     __XBIOS__(8)	Floprd( void *buf, void *filler, int  devno, int  sectno,
               int  trackno, int  sideno, int  count );
int     __XBIOS__(9)	Flopwr( void *buf, void *filler, int  devno, int  sectno,
               int  trackno, int  sideno, int  count );
int     __XBIOS__(10)	Flopfmt( void *buf, void *filler, int  devno, int  spt, int  trackno,
                int  sideno, int  interlv, long magic, int  virgin );
void    __XBIOS__(12)	Midiws( int  cnt, void *ptr );
void    __XBIOS__(13)	Mfpint( int  erno, void (*vector)() );
IOREC *	__XBIOS__(14)	Iorec( int  dev );
long    __XBIOS__(15)	Rsconf( int  baud, int  ctr, int  ucr, int  rsr, int  tsr, int  scr );
KEYTAB *__XBIOS__(16)	Keytbl( void *unshift, void *shift, void *capslock );
long    __XBIOS__(17)	Random( void );
void    __XBIOS__(18)	Protobt( void *buf, long serialno, int  disktype, int  execflag );
int     __XBIOS__(19)	Flopver( void *buf, void *filler, int  devno, int  sectno,
                int  trackno, int  sideno, int  count );
void    __XBIOS__(20)	Scrdmp( void );
int     __XBIOS__(21)	Cursconf( int  func, int  rate );
void    __XBIOS__(22)	Settime( unsigned long time );
unsigned
long	__XBIOS__(23)	Gettime( void );
void    __XBIOS__(24)	Bioskeys( void );
void    __XBIOS__(25)	Ikbdws( int  count, void *ptr );
void    __XBIOS__(26)	Jdisint( int  number );
void    __XBIOS__(27)	Jenabint( int  number );
char    __XBIOS__(28)	Giaccess( char data, int  regno );
void    __XBIOS__(29)	Offgibit( int  bitno );
void    __XBIOS__(30)	Ongibit( int  bitno );
void    __XBIOS__(31)	Xbtimer( int  timer, int  control, int  data, void (*vector)() );
void *  __XBIOS__(32)	Dosound( void *buf );
int     __XBIOS__(33)	Setprt( int  config );
KBDVBASE * __XBIOS__(34)Kbdvbase( void );
int     __XBIOS__(35)	Kbrate( int  initial, int  repeat );
void    __XBIOS__(36)	Prtblk( PBDEF *par );
void    __XBIOS__(37)	Vsync( void );
typedef long Supfunc(void);
long    __XBIOS__(38)	Supexec( Supfunc * );
void    __XBIOS__(39)	Puntaes( void );
int     __XBIOS__(41)	Floprate( int  devno, int  newrate );
int     __XBIOS__(64)	Blitmode( int  mo );

/* TOS030 XBios */
int    __XBIOS__(42)	DMAread( long sector, int  count, void *buffer, int  devno );
int    __XBIOS__(43)	DMAwrite( long sector, int  count, void *buffer, int  devno );
long   __XBIOS__(44)	Bconmap( int  devno );
int    __XBIOS__(46)	NVMaccess( int  opcode, int  start, int  count, void *buffer );
int    __XBIOS__(80)	Esetshift( int  shftMode );
int    __XBIOS__(81)	Egetshift( void );
int    __XBIOS__(82)	EsetBank( int  bankNum );
int    __XBIOS__(83)	EsetColor( int  colorNum, int  color );
void   __XBIOS__(84)	EsetPalette( int  colorNum, int  count, int  *palettePtr );
void   __XBIOS__(85)	EgetPalette( int  colorNum, int  count, int  *palettePtr );
int    __XBIOS__(86)	EsetGray( int  swtch );
int    __XBIOS__(87)	EsetSmear( int  swtch );

#if  !defined( __SIGNAL__ )
#define __SIGNAL__
/* signal handling */

#define NSIG       31       /* number of signals recognized   */

#define SIGNULL     0       /* not really a signal             */
#define SIGHUP      1       /* hangup signal                   */
#define SIGINT      2       /* sent by ^C                      */
#define SIGQUIT     3       /* quit signal                     */
#define SIGILL      4       /* illegal instruction             */
#define SIGTRAP     5       /* trace trap                      */
#define SIGABRT     6       /* abort signal                    */
#define SIGPRIV     7       /* privilege violation             */
#define SIGFPE      8       /* divide by zero                  */
#define SIGKILL     9       /* cannot be ignored               */
#define SIGBUS     10       /* bus error                       */
#define SIGSEGV    11       /* illegal memory reference        */
#define SIGSYS     12       /* bad argument to a system call   */
#define SIGPIPE    13       /* broken pipe                     */
#define SIGALRM    14       /* alarm clock                     */
#define SIGTERM    15       /* software termination signal     */
#define SIGURG     16       /* urgent condition on I/O channel */
#define SIGSTOP    17       /* stop signal not from terminal   */
#define SIGTSTP    18       /* stop signal from terminal       */
#define SIGCONT    19       /* continue stopped process        */
#define SIGCHLD    20       /* child stopped or exited         */
#define SIGTTIN    21       /* read by background process      */
#define SIGTTOU    22       /* write by background process     */
#define SIGIO      23       /* I/O possible on a descriptor    */
#define SIGXCPU    24       /* CPU time exhausted              */
#define SIGXFSZ    25       /* file size limited exceeded      */
#define SIGVTALRM  26       /* virtual timer alarm             */
#define SIGPROF    27       /* profiling timer expired         */
#define SIGWINCH   28       /* window size changed             */
#define SIGUSR1    29       /* user signal 1                   */
#define SIGUSR2    30       /* user signal 2                   */

#define SIG_DFL    0        /* default signal handler          */
#define SIG_IGN    1        /* ignore the signal               */
#endif

#ifndef S_IFMT

/* file types (Could be already in mint.h) */
#define S_IFMT  0170000     /* mask to select file type */
#define S_IFCHR 0020000     /* BIOS special file */
#define S_IFDIR 0040000     /* directory file */
#define S_IFREG 0100000     /* regular file */
#define S_IFIFO 0120000     /* FIFO */
#define S_IMEM  0140000     /* memory region or process */
#define S_IFLNK 0160000     /* symbolic link */

/* special bits: setuid, setgid, sticky bit */
#define S_ISUID 0004000
#define S_ISGID 0002000
#define S_ISVTX 0001000

/* file access modes for user, group, and other*/
#define S_IRUSR 0000400
#define S_IWUSR 0000200
#define S_IXUSR 0000100
#define S_IRGRP 0000040
#define S_IWGRP 0000020
#define S_IXGRP 0000010
#define S_IROTH 0000004
#define S_IWOTH 0000002
#define S_IXOTH 0000001

#define DEFAULT_DIRMODE (0777)
#if 0
#define DEFAULT_MODE    (0666)
#endif

typedef struct
{
        long     msg1;
        long     msg2;
        int      pid;
} MSG;

typedef struct
{
        unsigned int   mode;
        long           index;
        unsigned int   dev;
        unsigned int   reserved1;
        unsigned int   nlink;
        unsigned int   uid;
        unsigned int   gid;
        long           size;
        long           blksize;
        long           nblocks;
        int            mtime;
        int            mdate;
        int            atime;
        int            adate;
        int            ctime;
        int            cdate;
        int            attr;
        int            reserved2;
        long           reserved3[2];
} XATTR;


#define SA_NOCLDSTOP    1

typedef struct
{
        void    (*sa_handler)( long sig );
        long    sa_mask;
        int     sa_flags;
} SIGACTION;

typedef struct
{
        long     msg1;
        long     msg2;
        int      pid;
} __MSG;

#endif		/* S_IFMT */

int    __GEMDOS__(0xff)	Syield( void );
int    __GEMDOS__(0x100)	Fpipe( int  *usrh );
int    __GEMDOS__(0x104)	Fcntl( int  f, long arg, int  cmd );
long   __GEMDOS__(0x105)	Finstat( int  f );
long   __GEMDOS__(0x106)	Foutstat( int  f );
long   __GEMDOS__(0x107)	Fgetchar( int  f, int  mo );
long   __GEMDOS__(0x108)	Fputchar( int  f, long c, int  mo );
long   __GEMDOS__(0x109)	Pwait( void );
int    __GEMDOS__(0x10a)	Pnice( int  delta );
int    __GEMDOS__(0x10b)	Pgetpid( void );
int    __GEMDOS__(0x10c)	Pgetppid( void );
int    __GEMDOS__(0x10d)	Pgetpgrp( void );
int    __GEMDOS__(0x10e)	Psetpgrp( int  pid, int  newgrp );
int    __GEMDOS__(0x10f)	Pgetuid( void );
int    __GEMDOS__(0x110)	Psetuid( int  id );
int    __GEMDOS__(0x111)	Pkill( int  pid, int  sig );
int    __GEMDOS__(0x113)	Pvfork( void );
int    __GEMDOS__(0x114)	Pgetgid( void );
int    __GEMDOS__(0x115)	Psetgid( int  id );
long   __GEMDOS__(0x116)	Psigblock( long mask );
long   __GEMDOS__(0x117)	Psigsetmask( long mask );
long   __GEMDOS__(0x118)	Pusrval( long arg );
void   __GEMDOS__(0x11a)	Psigreturn( void );
int    __GEMDOS__(0x11b)	Pfork( void );
long   __GEMDOS__(0x11c)	Pwait3( int  flag, long *rusage );
int    __GEMDOS__(0x11d)	Fselect( unsigned int  timeout, long *rfds, long *wfds, long *xfds );
void   __GEMDOS__(0x11e)	Prusage( long *r );
long   __GEMDOS__(0x11f)	Psetlimit( int  lim, long value );
long   __GEMDOS__(0x120)	Talarm( long secs );
void   __GEMDOS__(0x121)	Pause( void );
long   __GEMDOS__(0x122)	Sysconf( int  n );
long   __GEMDOS__(0x123)	Psigpending( void );
long   __GEMDOS__(0x124)	Dpathconf( char *name, int  n );
long   __GEMDOS__(0x125)	Pmsg( int  mo, long mbox, __MSG *msg );
long   __GEMDOS__(0x126)	Fmidipipe( int  pid, int  in, int  out );
int    __GEMDOS__(0x127)	Prenice( int  pid, int  delta );
long   __GEMDOS__(0x128)	Dopendir( const char *name, int  flag );
long   __GEMDOS__(0x129)	Dreaddir( int  buflen, long dir, char *buf );
long   __GEMDOS__(0x12a)	Drewinddir( long dir );
long   __GEMDOS__(0x12b)	Dclosedir( long dir );
long   __GEMDOS__(0x12c)	Fxattr( int  flag, const char *name, XATTR *buf );
long   __GEMDOS__(0x12d)	Flink( char *oldname, char *newname );
long   __GEMDOS__(0x12e)	Fsymlink( char *oldname, char *newname );
long   __GEMDOS__(0x12f)	Freadlink( int  size, char *buf, char *name );
long   __GEMDOS__(0x130)	Dcntl( int  cmd, char *name, long arg );
long   __GEMDOS__(0x131)	Fchown( char *name, int  uid, int  gid );
long   __GEMDOS__(0x132)	Fchmod( char *name, int  mo );
long   __GEMDOS__(0x133)	Pumask( unsigned int  mo );
long   __GEMDOS__(0x134)	Psemaphore( int  mo, long id, long timeout );
long   __GEMDOS__(0x135)	Dlock( int  mo, int  drive );
void   __GEMDOS__(0x136)	Psigpause( unsigned long mask );
long   __GEMDOS__(0x137)	Psigaction( int  sig, SIGACTION *act, SIGACTION *oact );
int    __GEMDOS__(0x138)	Pgeteuid( void );
int    __GEMDOS__(0x139)	Pgetegid( void );
long   __GEMDOS__(0x13b)	Dgetcwd( char *path, int  drv, int  size );
long   __GEMDOS__(0x13a)	Pwaitpid( int  pid, int  flag, long *rusage );
long   __GEMDOS__(0x13c)	Salert(char *msg);

/* Falcon */

#define VERTFLAG          0x0100
#define STMODES           0x0080
#define OVERSCAN          0x0040
#define PAL               0x0020
#define VGA_FALCON        0x0010
#define TV                0x0000

#define COL80             0x08
#define COL40             0x00

#define BPS16             4
#define BPS8              3
#define BPS4              2
#define BPS2              1
#define BPS1              0

#define NUMCOLS           7


typedef struct
{
    int     blocktype;
    long    blocksize;
    void    *blockaddr;
} DSPBLOCK;


void    __XBIOS__(  5)	VsetScreen( void *log, void *phys, int mode, int modecode);
int     __XBIOS__( 88)	Vsetmode( int modecode );
int     __XBIOS__( 89)	mon_type( void );
int     __XBIOS__( 89)	VgetMonitor( void );
void    __XBIOS__( 90)	VsetSync( int flag );
long    __XBIOS__( 91)	VgetSize( int mode );
void    __XBIOS__( 92)	VsetMask( int ormask, int andmask, int overlay );
void    __XBIOS__( 93)	VsetRGB( int index, int count, long *array );
void    __XBIOS__( 94)	VgetRGB( int index, int count, long *array );
int     __XBIOS__( 95)	VcheckMode( int modecode );
int     __XBIOS__( 95)	ValidMode( int modecode );

void    __XBIOS__( 96)	Dsp_DoBlock( char *data_in, long size_in, char *data_out,
                     long size_out );
void    __XBIOS__( 97)	Dsp_BlkHandShake( char *data_in, long size_in, char *data_out,
                          long size_out );
void    __XBIOS__( 98)	Dsp_BlkUnpacked( long *data_in, long size_in, long *data_out,
                         long size_out );
void    __XBIOS__( 99)	Dsp_InStream( char *data_in, long block_size, long num_blocks,
                      long *blocks_done );
void    __XBIOS__(100)	Dsp_OutStream( char *data_out, long block_size, long num_blocks,
                       long *blocks_done );
void    __XBIOS__(101)	Dsp_IOStream( char *data_in, char *data_out, long block_insize,
                      long block_outsize, long num_blocks,
                      long *blocks_done );
void    __XBIOS__(102)	Dsp_RemoveInterrupts( int mask );
int     __XBIOS__(103)	Dsp_GetWordSize( void );
int     __XBIOS__(104)	Dsp_Lock( void );
void    __XBIOS__(105)	Dsp_Unlock( void );
void    __XBIOS__(106)	Dsp_Available( long *xavailable, long *yavailable );
int     __XBIOS__(107)	Dsp_Reserve( long xreserve, long yreserve );
int     __XBIOS__(108)	Dsp_LoadProg( char *file, int ability, char *buffer );
void    __XBIOS__(109)	Dsp_ExecProg( char *codeptr, long codesize, int ability );
void    __XBIOS__(110)	Dsp_ExecBoot( char *codeptr, long codesize, int ability );
long    __XBIOS__(111)	Dsp_LodToBinary( char *file, char *codeptr );
void    __XBIOS__(112)	Dsp_TriggerHC( int vector );
int     __XBIOS__(113)	Dsp_RequestUniqueAbility( void );
int     __XBIOS__(114)	Dsp_GetProgAbility( void );
void    __XBIOS__(115)	Dsp_FlushSubroutines( void );
int     __XBIOS__(116)	Dsp_LoadSubroutine( char *codeptr, long codesize, int ability );
int     __XBIOS__(117)	Dsp_InqSubrAbility( int ability );
int     __XBIOS__(118)	Dsp_RunSubroutine( int handle );
int     __XBIOS__(119)	Dsp_Hf0( int flag );
int     __XBIOS__(120)	Dsp_Hf1( int flag );
int     __XBIOS__(121)	Dsp_Hf2( void );
int     __XBIOS__(122)	Dsp_Hf3( void );
void    __XBIOS__(123)	Dsp_BlkWords( void *data_in, long size_in, void *data_out,
                      long size_out );
void    __XBIOS__(124)	Dsp_BlkBytes( void *data_in, long size_in, void *data_out,
                      long size_out );
char    __XBIOS__(125)	Dsp_HStat( void );
void    __XBIOS__(126)	Dsp_SetVectors( void (*receiver)( ), long (*transmitter)( ));
void    __XBIOS__(127)	Dsp_MultBlocks( long numsend, long numreceive,
                        DSPBLOCK *sendblocks, DSPBLOCK *receiveblocks );

long    __XBIOS__(128)	locksnd( void );
long    __XBIOS__(129)	unlocksnd( void );
long    __XBIOS__(130)	soundcmd( int mode, int data );
long    __XBIOS__(131)	setbuffer( int reg, void *begaddr, void *endaddr );
long    __XBIOS__(132)	setmode( int mode );
long    __XBIOS__(133)	settracks( int playtracks, int rectracks );
long    __XBIOS__(134)	setmontracks( int montrack );
long    __XBIOS__(135)	setinterrupt( int src_inter, int cause );
long    __XBIOS__(136)	buffoper( int mode );
long    __XBIOS__(137)	dsptristate( int dspxmit, int dsprec );
long    __XBIOS__(138)	gpio( int mode, int data );
long    __XBIOS__(139)	devconnect( int src, int dst, int srcclk, int prescale,
                    int protocol );
long    __XBIOS__(140)	sndstatus( int reset );
long    __XBIOS__(141)	buffptr( long *ptr );

/*		__XBIOS__(150)	VsetVars ( ?????? );	*/

int     __XBIOS__(165)	WavePlay( int flags, long rate, void *sptr, long slen );

#endif

/************************************************************************/
